import pango
import gtk


class InfoView(gtk.VBox):
	def __init__(self,data):
		gtk.VBox.__init__(self,False,0)
		self.data = data
		self.title = self.makeLabel("",13000,700)
		self.album = self.makeLabel("",10000,400)
		self.artist = self.makeLabel("",10000,400)
		self.changeLabels()
		self.show()


	# Called when the song changes
	def changeLabels(self):
		title = ""
		album = ""
		artist = ""
		if self.data.song:
			title = self.data.song.info.title.title()
			album = "from "+self.data.song.info.album.title()
			artist = "by "+self.data.song.info.artist.title()
		self.title.set_text(title)
		self.album.set_text(album)
		self.artist.set_text(artist)


	# Set the text, font, and weight of a label
	def makeLabel(self,text,size,weight):
		label = gtk.Label(text)
		align = gtk.Alignment(0,1,0,0)
		attr = pango.AttrList()
		attr.insert(pango.AttrSize(size,0,-1))
		attr.insert(pango.AttrWeight(weight,0,-1))
		label.set_attributes(attr)
		align.add(label)
		self.pack_start(align,False,False,0)
		label.show()
		align.show()
		return label
